<template>
  <div :class="{ 'vlow-node': true, 'has-left': hasLeftside, 'has-right': hasRightside}" :rel="content.id" :style="'--rows:'+rows">
    <div
        class="title"
        v-text="proto.title"
        @mousedown.prevent="$emit('start-drag', $event)"
    />
    <template v-for="(cfg, input, n) in proto.inputs" :key="input+'pin'">
      <div

          :class="'name left row'+n"
          v-text="cfg.label || input"
      />

      <div
          v-if="content.node[input].type === 'connection'"
          :rel="input"
          :class="'input left row'+n"
          v-html="'&middot;'"
      />

      <div
          v-if="content.node[input].type === 'constant'"
          :class="'value left row'+n"
          v-text="content.node[input].constant.value"
      />
    </template>

    <template v-for="(cfg, output, n) in proto.passthroughs" :key="output+'pin'">
      <span

          :class="'name left row'+(n+Object.keys(proto.inputs).length)"
          v-text="cfg.label || output"
      />
      <div
          :rel="output"
          :class="'output left row'+(n+Object.keys(proto.inputs).length)"
          v-html="'&middot;'"
      />
    </template>

    <template v-for="(cfg, output, n) in proto.outputs" :key="output+'dot'">
      <div
          :class="'name right row'+n"
          v-text="cfg.label || output"
      />
      <div

          :rel="output"
          :class="'output right row'+n"
          v-html="'&middot;'"
      />
    </template>

    <template v-for="(cfg, input, n) in proto.collects" :key="input+'pin'">
      <div

          :class="'name right row'+(n+Object.keys(proto.outputs).length)"
          v-text="cfg.label || input"
      />

      <div
          v-if="content.node[input].type === 'connection'"
          :rel="input"
          :class="'input right row'+(n+Object.keys(proto.outputs).length)"
          v-html="'&middot;'"
      />

      <div
          v-if="content.node[input].type === 'constant'"
          :class="'value right row'+(n+Object.keys(proto.outputs).length)"
          v-text="content.node[input].constant.value"
          :datasrc="cfg"
      />
    </template>

    <component v-if="contentComponent" :is="contentComponent" :node="content.node" class="content" />
    <div v-else-if="proto.passthroughs" class="content" :style="{width: content.width+'px', height: content.height+'px'}" />
  </div>
</template>

<script>
import {getRowsInNodeProto} from "../utils.js";
import StringInterpolation from "./custom-content/StringInterpolation.vue";
import Math from "./custom-content/Math.vue"

export default {
  name: "Node",
  components: {
    StringInterpolation,
    Math
  },
  props: {
    proto: Object,
    content: Object
  },
  computed: {
    rows() {
      return getRowsInNodeProto(this.proto)
    },
    hasLeftside() {
      return !!this.proto.inputs || !!this.proto.passthroughs
    },
    hasRightside() {
      return !!this.proto.outputs || !!this.proto.collects
    },
    contentComponent() {
      const name = `custom-content-${this.content.type}`
      const bla = Object.entries(this.$options.components).find(([, comp]) => comp.name === name);
      return bla ? bla[0] : undefined
    }
  }
}
</script>

<style lang="scss">
.vlow-node {
  --rows: 1;
  display: grid;

  &.has-right {
    grid-template-columns: auto 15px minmax(auto, 1fr) 15px;
  }

  &.has-left {
    grid-template-columns: 15px minmax(auto, 1fr) minmax(15px, auto) auto;
  }

  &.has-left.has-right {
    grid-template-columns: 15px minmax(auto, 1fr) minmax(15px, auto) auto 15px minmax(auto, 1fr) 15px;
  }

  grid-template-rows: var(--vlow-node-title-height) repeat(var(--rows), var(--vlow-node-row-height)) auto;


  .title {
    grid-row: 1;
    grid-column: 1/-1;
  }

  .content {
    grid-column: 4;
    grid-row: 2/-1;
    overflow: hidden;
  }

  @for $i from 0 through 9 {
    .row#{$i} {
      grid-row: #{$i + 2};
    }
  }

  .input.left {
    grid-column: 1;
  }

  .output.left {
    grid-column: 3;
  }


  .input.right {
    grid-column: -4;
  }

  .output.right {
    grid-column: -2;
  }

  .name.left {
    grid-column: 2;
  }

  .value.left {
    grid-column: 3;
  }

  .name.right {
    grid-column: -3;
  }


  .input, .output {
    text-align: center;
  }
}
</style>
